package com.example.demo;

import java.util.List;
import java.util.Objects;
import java.util.stream.IntStream;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.boot.CommandLineRunner;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import com.example.demo.users.service.UserService;
import com.example.demo.videos.service.VideoService;
import com.example.demo.users.model.UserEntity;
import com.example.demo.users.model.UserRole;
import com.example.demo.videos.model.VideoEntity;

import com.example.demo.core.configuration.Constants;
import com.example.demo.users.model.UserEntity;

@SpringBootApplication
public class DemoApplication implements CommandLineRunner {
    private final Logger log = LoggerFactory.getLogger(DemoApplication.class);
    private final UserService userService;
    private final VideoService videoService;

    public DemoApplication(UserService user, VideoService video) {
        userService = user;
        videoService = video;
    }

    public static void main(String[] args) {
        SpringApplication.run(DemoApplication.class, args);
    }

    @Override
    public void run(String... args) throws Exception {
        if (args.length > 0 && Objects.equals("--populate", args[0]) && false) {
            final var user1 = userService.create(new UserEntity("login", "pass"));
            final var user2 = userService.create(new UserEntity("aaa", "pass"));
            user1.setRole(UserRole.ADMIN);

            videoService.create(new VideoEntity(user1, "aboba", "boba", "oba", "ba"));
            videoService.create(new VideoEntity(user2, "cicic", "icic", "ici", "i"));

        }
    }
}
