package com.example.demo.likes.model;

import java.util.Objects;

import com.example.demo.core.model.BaseEntity;
import com.example.demo.videos.model.VideoEntity;

import jakarta.persistence.Entity;
import jakarta.persistence.JoinColumn;
import jakarta.persistence.ManyToOne;
import jakarta.persistence.Table;

import com.example.demo.users.model.UserEntity;

@Entity
@Table(name = "likes")
public class LikeEntity extends BaseEntity {
    @ManyToOne
    @JoinColumn(name = "videoId")
    private VideoEntity video;
    @ManyToOne
    @JoinColumn(name = "userId")
    private UserEntity user;

    public LikeEntity() {
    }

    public LikeEntity(VideoEntity video, UserEntity user) {
        this.video = video;
        this.user = user;
    }

    public UserEntity getUser() {
        return user;
    }

    public void setUser(UserEntity user) {
        this.user = user;
    }

    public VideoEntity getVideo() {
        return video;
    }

    public void setVideo(VideoEntity video) {
        this.video = video;
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, user, video);
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null || getClass() != obj.getClass())
            return false;
        final LikeEntity other = (LikeEntity) obj;
        return Objects.equals(other.getId(), getId())
                && Objects.equals(other.getUser(), getUser())
                && Objects.equals(other.getVideo(), getVideo());
    }

}
