package com.example.demo.videos.model;

import java.util.Objects;

import com.example.demo.core.model.BaseEntity;
import com.example.demo.users.model.UserEntity;

import jakarta.persistence.Column;
import jakarta.persistence.Entity;
import jakarta.persistence.JoinColumn;
import jakarta.persistence.ManyToOne;
import jakarta.persistence.Table;

@Entity
@Table(name = "videos")
public class VideoEntity extends BaseEntity {
    @ManyToOne
    @JoinColumn(name = "userId")
    private UserEntity user;
    @Column(nullable = false, length = 30)
    private String title;
    @Column(nullable = false, length = 30)
    private String description;
    @Column(nullable = false, length = 30)
    private String image;
    @Column(nullable = false, length = 30)
    private String vid;

    public VideoEntity() {
    }

    public VideoEntity(UserEntity user, String title, String description, String image, String vid) {
        this.title = title;
        this.user = user;
        this.description = description;
        this.image = image;
        this.vid = vid;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public String getImage() {
        return image;
    }

    public void setImage(String image) {
        this.image = image;
    }

    public UserEntity getUser() {
        return user;
    }

    public void setUser(UserEntity user) {
        this.user = user;
    }

    public String getTitle() {
        return title;
    }

    public void setTitle(String title) {
        this.title = title;
    }

    public String getVid() {
        return vid;
    }

    public void setVid(String vid) {
        this.vid = vid;
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, user, title, description, image, vid);
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null || getClass() != obj.getClass())
            return false;
        final VideoEntity other = (VideoEntity) obj;
        return Objects.equals(other.getId(), getId())
                && Objects.equals(other.getUser(), getUser())
                && Objects.equals(other.getTitle(), getTitle())
                && Objects.equals(other.getDescription(), getDescription())
                && Objects.equals(other.getImage(), getImage())
                && Objects.equals(other.getVid(), getVid());
    }
}
